import java.util.List;
import java.util.Arrays;
import java.util.functions.Predicate;

class StockAndPrice {
 public final String ticker;
 public final double price;
 
 public StockAndPrice(String theTicker, double stockPrice) {
   ticker = theTicker;
   price = stockPrice;
 } 
 
 public String toString() {
   return ticker + ":" + price;
 }
}

public class Sample {
  public static void main(String[] args) {
    long start = System.nanoTime();
    List<String> tickers = Arrays.asList("AAPL", "AMD", "CSCO", "GOOG", "HPQ", "INTC", "MSFT", "ORCL", "QCOM", "XRX");

    StockAndPrice highestPriced = 
      tickers.map(ticker -> new StockAndPrice(ticker, YahooFinance.getPrice(ticker)))
      .reduce(new StockAndPrice("", 0.0), (s1, s2) -> (s1.price > s2.price) ? s1 : s2);
      
    long end = System.nanoTime();
    System.out.println("The highest priced stock is " + highestPriced.ticker +
      " at price $" + highestPriced.price);
    System.out.println("Time taken in seconds: " + (end - start)/1.0e9);
  }
}
