import java.util.Collection;
import java.util.Arrays;
import java.util.functions.Predicate;

public class Sample {
  public static int totalValues(Collection<Integer> prices, Predicate<Integer> predicate) {
    int total = 0;
    
    for(int price : prices) {
      if (predicate.eval(price)) total += price;
    }
    
    return total;
  }
  
  public static void main(String[] args) {
    Collection<Integer> prices = Arrays.asList(1, 2, 3, 4, 5, 6);
    
    System.out.println(totalValues(prices, price -> true));
    System.out.println(totalValues(prices, price -> price % 2 == 0));
    System.out.println(totalValues(prices, price -> price % 2 != 0));
  }
}